/* *********************************************************************************
 	
 	 MODULE:		CheckEmail Module
 	 
     DESCRIPTION:	This CheckEmail Module is a simple module for MUBBS, the
     				Multi-User Bulliten Board System Software.
     				
     AUTHOR:		Noam Freedman
     
     Copyright  1990 by Noam Freedman. Portions are also Copyright Symantec Corp.

     This program source code and it's compiled version IS NOT IN THE
     PUBLIC DOMAIN ! Please read the "COPYRIGHT NOTICE / NMF" file for details
     regarding use of this program source code and it's compiled version.
     
     Revision History:
     ============================================================
     10/20/91 - Started programming
     11/ 4/91 - Edited for release
     ============================================================
     
 
	******************************************************************************** */

#define		INMAIN


#include	"MUBBS Module.h"
#include	"Email.h"
#include	<SetUpA4.h>


pascal void main (mode1,G1,P1)
       int mode1;
       struct GS *G1;
       Ptr P1;  
{
Handle temph;
float version = 0.5; /* what version of MUBBS you are compatable with IE: .5 and above */
RememberA0(); SetUpA4(); /* This sets up the A4 register to access our globals */
asm { _RecoverHandle }; asm {move.l a0,temph}; HLock(temph); /* locks our module, do this ! */

G=G1; /* This MUST be the first thing you do in main only, it sets up the struct globals */
mode[u]=mode1; /* set up our mode so that you can read it anywhere */


switch (mode[u]) { /* any un-handled modes return error from this module */
	case 3:
		findemail(P1); /* mode 3 because we are passing a user pointer */
		G->moduleresult=0;
		break;
	case 98:
		versionck(version); /* just return after this call, don't modify anything */
		break;		
	case 0:
		strcpy (G->programmer,"Noam Freedman"); /* show the programmer's name up to 20 chars*/
		G->moduleresult=0; /* this was also a init call if we need close call put 99 here */
		break;
	default:
		G->moduleresult=1; /* return bad code */
	};

HUnlock(temph); /* unlocks this module, do this ! */
RestoreA4(); /* call this when you are all done */
}


findemail(S)
struct LoadStruct *S;
{
char pad[100]; /* this is a fix for a problem */
struct MsgStruct MsgInfo;
int a, num, numemail, count;
FILE *fp_headers;
long int temp;
char tempc[maxnamelength];

if (!G->online[u]) { num = 2;goto byebye; } /* do this check so we can log out if hang up */


if ( (fp_headers = fopen(":msgs:email.headers","r")) == NULL )
	{
	send("]Can't open the file: %s]]",":msgs:email.headers");
	num = 3;
	}
else
	{
	count=0;
	a = 0;
	num = 0;
	numemail=0;
	while (a == 0)
		{	
		temp = ftell(fp_headers);
		fread( MsgInfo.FromUser, sizeof(MsgInfo),1,fp_headers);	
		if (feof(fp_headers) == 0)
			{
			if ( numemail < MAXEMAIL )
				{
				strtoupper(MsgInfo.ToUser);
				strcpy(tempc,G->username[u]); /* check the name uppercased! */
				strtoupper(tempc);
				if (strcmp(MsgInfo.ToUser,tempc) == 0)
				if (MsgInfo.status != DELETED )
					{
					numemail = numemail+1;
					S->i_headers[numemail] = temp;
					strcpy( S->FromUser[numemail] , MsgInfo.FromUser );
					strcpy( S->title[numemail] , MsgInfo.title );
					S->status[numemail] = MsgInfo.status;
					strcpy( S->NetAddress[numemail] , MsgInfo.NetAddress);
					S->offset[numemail] = MsgInfo.offset;
					S->length[numemail] = MsgInfo.length;
					strcpy( S->DateSent[numemail] , MsgInfo.DateSent);
					}
				}
			else
				{
				a = 1;	/* More than MAXEMAIL msgs */
				num = 20;
				}
			}
		else
			{
			a = 1; /* ran into EOF */
			num = 0;
			}
		if ((++count % 10) == 0) {sendnc (".");} /* show dots */
		}
	fclose(fp_headers); /* close that file ! */
	}
if(numemail <1 && num == 0)
	{
	num = 21;  /* No email found */
	}

S->numemail = numemail;
byebye:
S->result = num;
return;
}

